/* Ar3sgice's Random Osu! Beatmap Script v0.01 */

/* constants */

var timeStart = 2022;
var timeEnd = 180022;
var timeTick = 250; /* (60000/BPM) / BeatSnapDivisor */
var L = 0;
var R = 512;
var T = 0;
var B = 384; /* osu height=384 width=512 */
var pb_slider = 0.3; /* Probabilities */
var pb_spinner = 0.03;
var pb_newcombo = 0.125; /* tag4? */
var pb_whistle = 0.1;
var pb_clap = 0.1;
var pb_finish = 0.05;
var spinnerLeastTicks = 2;
var spinnerMostTicks = 12;
var slider_baselength = 150; /* this relates to BPM, Divisor and slider speed */
var vinfo = "Random_" + Math.floor(Math.random()*10000); /* Difficulty */
var fileoutname = "Blizzard Entertainment - Radio Free Zerg ([CSGA]Ar3sgice) [" + vinfo + "].osu";
var prefsname = "prefs2.osh";
var colorLimit = 8;
var sliderBounces = function()
{
	if(Math.random() < 0.05)
	{
		return 3;
	}
	else if(Math.random() < 0.25)
	{
		return 2;
	}
	return 1;
}
sliderBounces.toString = sliderBounces;
sliderBounces.valueOf = sliderBounces;
var sliderTicks = function()
{
	if(Math.random() < 0.035)
	{
		return 3;
	}
	else if(Math.random() < 0.2)
	{
		return 2;
	}
	else
	{
		return 1;
	}
}
sliderTicks.toString = sliderTicks;
sliderTicks.valueOf = sliderTicks;

var curTicks = 0;

/* call FSO */

var fso = new ActiveXObject("Scripting.FileSystemObject");

function r()
{
	return Math.random();
}
r.valueOf = r;
r.toString = r;

function t(i)
{
	return (i * timeTick + timeStart);
}

function f(i)
{
	return Math.floor(i);
}

function hs()
{
	var o = 0;
	if(r < pb_whistle)
	{
		o += 2;
	}
	if(r < pb_finish)
	{
		o += 4;
	}
	if(r < pb_clap)
	{
		o += 8;
	}
	return o;
	/* Finish+4 Whistle+2 Clap+8 */
}

function circle(ct)
{
	var x = f(L + r * (R-L));
	var y = f(T + r * (B-T));
	var time = t(curTicks);
	var arg4 = (r<pb_newcombo)?5:1;
	var arg5 = hs();
	curTicks++;
	return (x + "," + y + "," + time + "," + arg4 + "," + arg5);
	/* x,y,time,isNewCombo/noteType,Whistle/Clap/Finish */
}

function slider()
{
	var x = f(L + r * (R-L));
	var y = f(T + r * (B-T));
	var time = t(curTicks);
	var arg4 = (r<pb_newcombo)?6:2;
	var arg5 = hs();
	var st = 1 * sliderTicks;
	var arg7 = 1 * sliderBounces;
	var arg8 = slider_baselength * st;
	var arg6 = "B";
	var tx = x;
	var ty = y;
	var t1x = 0;
	var t1y = 0;
	var angle = 0;
	for(var i=0;i<st;i++)
	{
		do
		{
			angle = 2 * Math.PI * r;
			t1x = f(tx + slider_baselength * Math.cos(angle));
			t1y = f(ty + slider_baselength * Math.sin(angle));
		}
		while(t1x < L || t1y < T || t1x > R || t1y > B);
		tx = t1x;
		ty = t1y;
		arg6 += "|" + tx + ":" + ty;
		if(i < st - 1)
		{
			arg6 += "|" + tx + ":" + ty;
		}
	}
	curTicks += st * arg7 + 1;
	return (x + "," + y + "," + time + "," + arg4 + "," + arg5 + "," + arg6 + "," + arg7 + "," + arg8);
	/* X,Y,TIME,2/6,Whistle/Clap/Finish,B|Points (X:Y),BounceTimes,TimeLength */
}

function spinner()
{
	var x = 240;
	var y = 192;
	var time = t(curTicks);
	var arg4 = 12;
	var arg5 = hs();
	var st = f(spinnerLeastTicks + r * (spinnerMostTicks - spinnerLeastTicks));
	var endtime = t(curTicks + st);
	curTicks += st + 1;
	return (x + "," + y + "," + time + "," + arg4 + "," + arg5 + "," + endtime);
	/* X,Y,TIME,12,Whistle/Clap/Finish,EndTime */
}

var combo_colors = "[Colours]";
for(var i=1;i<=colorLimit;i++)
{
	combo_colors += "\r\n" + "Combo" + i + " : " + f(r*256) + "," + f(r*256) + "," + f(r*256);
}

var out = "[HitObjects]";
var totalTicks = Math.floor((timeEnd - timeStart) / timeTick);
var cx = "";

while(curTicks < totalTicks)
{
	if(r < pb_slider)
	{
		cx = slider();
	}
	else if(r < pb_spinner / (1 - pb_slider))
	{
		cx = spinner();
	}
	else
	{
		cx = circle();
	}
	if(curTicks <= totalTicks)
	{
		out += "\r\n" + cx;
	}
}

var fp2 = fso.OpenTextFile(prefsname);
var fp2data = fp2.ReadAll();
fp2data = fp2data.replace("VERSION_TEXT_HERE",vinfo);
out = fp2data + "\r\n\r\n" + combo_colors + "\r\n\r\n" + out;
var outfile = fso.CreateTextFile(fileoutname);
outfile.Write(out);
outfile.Close();
/* WScript.Echo(colors); */
WScript.Quit();